#!/usr/bin/env python
#
# $Id$
#  
# a selection of functions and their associated control strings, for doing
# various stuff with muse.
#
# Started 27/9/01 by Damien Elmes <resolve@repose.cx>
# This file is licensed under the GPL.
#

import player
import playlist

from debug import debug

callbacks = []

def jump_to_artist(*all):
    if len(all)==0:
        # repeat last match
        player.jump_to_field()
        return
        
    search = all[0]
    if len(all)>1: search += " "
    search += " ".join(all[1:])
    player.jump_to_field('artist', search)

def jump_to_title(*all):
    if len(all)==0:
        # repeat last match
        player.jump_to_field()
        return
        
    search = all[0]
    if len(all)>1: search += " "
    search += " ".join(all[1:])
    player.jump_to_field('title', search)    
    
control_list = {
    "next"           : player.next,
    "prev"           : player.prev,
    "fwd"            : player.fwd,
    "back"           : player.back,
    "cur"            : player.play_current,
    "next-d"         : player.next_dir,
    "prev-d"         : player.prev_dir,
    "next-a"         : player.next_artist,
    "prev-a"         : player.prev_artist,
    "shutdown"       : player.quit,
    "pause"          : player.pause,
    "enqueue"        : player.add_to_queue,
    "nextp"          : playlist.list.next,
    "prevp"          : playlist.list.prev,
    "nextp-a"        : playlist.list.next_artist,
    "prevp-a"        : playlist.list.prev_artist,
    "prevp-d"        : playlist.list.prev_dir,
    "nextp-d"        : playlist.list.next_dir,
    "nextq"          : player.next_with_queue,
    "list"           : lambda: repr(playlist.list.list),
    "ja"             : jump_to_artist,
    "jt"             : jump_to_title,
    "help"           : lambda: "A quick list of available commands:\n" + \
                        repr(control_list.keys()),
    }

def cmd(str):
    """ Take a command - extra arguments are included in string. """

    if str.find("py: ")==0:
        # execute raw python code
        new = str[4:].strip()
        try: return eval(new)
        except:
            # FIXME: dump output back down.
            debug(2, "no eval: " + repr(new))
            return None
        
    else:
        foo = str.strip().split()

        cmd = foo[0]
        args = foo[1:]

        # fixme, make sane
        if control_list.has_key(cmd):
            report(cmd)
            return apply(control_list[cmd], args)



        else: return "Invalid command! Try 'help' for a list."

def report(cmd):
    """ report a command to all registered hooks """
    for x in callbacks: x(cmd)

def add_cb(hook):
    """ add a cb for report() """
    callbacks.append(hook)
        

    
        
        
        


    
    
        
        

    
        
    
