#!/usr/bin/env python

import sys
import os
import getopt

import ui
import player
import playlist
import fileops
import multiplex
import plugin
import fun

#import profile # REMOVEME

from debug import debug

plugins = []#('ui_remote_unix', 'ui_orbital', 'in_mpg123', 'ui_curses')
args = []
opts = []

def usage_information():
    print  'Usage: ' + sys.argv[0] + ' uri[, uri, ...]' + \
          """
          -p \t specify plugin to load. can be used multiple times."""
    

def parse_args():
    global plugins
    global args
    global opts

    if len(sys.argv) <= 1:
        usage_information()
        sys.exit(2)

    try:
        opts, args = getopt.getopt(sys.argv[1:], "p:")
    except getopt.GetoptError:
        usage_information()
        return

    debug(1, "opt, args = " + repr(opts) + repr(args))

    for x in opts:
        if x[0]=="-p":
            plugins.append(x[1])

def main():
    debug(1, "muse v0.1.9 starting..")
    debug(2, "using python 0x" + str(sys.hexversion) + "\n")

    parse_args()
    
    plugin.add(plugins)

    for x in args:
        fileops.add_uri_to_playlist(x)

    debug(1, "\nLoading complete.\n")

    ui.notice("muse loading...")
    ui.refresh()

    # we don't want to let the user interface take CPU away from the mpg321
    # process.

    os.system("renice 15 -p %d > /dev/null 2>&1" % os.getpid())

    playlist.list.sort()

    if len(playlist.list)==0:
        # this'll break on song-forward, etc at the moment. FIXME.
        ui.notice("warning, empty playlist on startup.")
        ui.refresh()

    # say hello :-)
    fun.welcome_message()

    # and then kick into the music
    player.start()

    ##
    ## main loop
    ##

    multiplex.main_loop()

    
if __name__ == "__main__":
    #profile.run('main()', 'profs')
    main()


