#!/usr/bin/env python
#
# ui.py - after loading a set of modules, ui.x() will call each module.x(),
#         where x is of course used to denote a variable :-)
#
# started 5/8/01 by Damien Elmes <resolve@repose.cx>
#

from debug import *

plugins = []

callbacks = {}
callback_types = ['song', 'status', 'time', 'notice']
for x in callback_types: callbacks[x] = []

def add_plugin(plugin):
    plugins.append(plugin.new())

def add_callback(type, cb):
    """ add a new callback, type is one of callback_types """
    if type not in callback_types:
        raise TypeError, "Unknown type"

    callbacks[type].append(cb)

def new_song():
    for x in callbacks['song']: x()

def new_time():
    for x in callbacks['time']: x()

def new_status():
    for x in callbacks['status']: x()

def notice(msg):
    for x in callbacks['notice']: x(msg)
    debug(2, "UI: " + msg)

def refresh():
    for x in plugins:
        try:
            x.refresh()
        except AttributeError: pass

class plugin:
    def __init__(self):
        pass
        




        
        

    
        
    
